/*****************************************************
CVAVR V2.05
Chip type               : ATmega8
AVR Core Clock frequency: 8 MHz
*****************************************************/
#include <mega8.h>

#define s_step 156
flash unsigned char s_table [s_step/2]=
{0,5,10,15,20,25,31,36,41,46,51,56,61,66,71,76,81,86,91,96,100,
105,110,115,119,124,128,133,137,141,146,150,154,158,162,166,170,174,178,181,185,189,
192,195,199,202,205,208,211,214,217,219,222,225,227,229,232,234,236,238,240,241,243,
245,246,247,249,250,251,252,253,253,254,254,254,254,255,255};

unsigned char c=0;
unsigned char tmr0, tmr1;

void t0_cfg()
{
 TCCR1A=0;
 TCCR1A=0; TCCR1A|=1<<COM1A1|1<<COM1B1|1<<COM1B0|1<<WGM10;
 TCCR1B=0;TCCR1B|=1<<CS00;
 TIMSK|=1<<TOIE1;
}
void gpio_cfg()
{
 PORTB=DDRB=0b00000110;     
 PORTD=DDRD=0b01000000; 
}

interrupt [TIM1_OVF] void t1_ovf_isr()
{
 #define dtv 4
 static bit dir;
 
 if(!c)                                          
 {
 dir=1;c=1;
 PORTD=0b01100000;
 PORTD=DDRD^=0b01100000;
 if(tmr0)tmr0--;    
 if(tmr1)tmr1--;
 }
 else if((dir)&&(c<s_step/2-1))
    {
    OCR1BL=0xff-s_table[c];
    if((OCR1BL<0xff-dtv)&&(OCR1BL)){OCR1AL=OCR1BL+dtv;}
    else{OCR1AL=0;} c++;
    }  
 else 
    {
    OCR1BL=0xff-s_table[c];
    if((OCR1BL<0xff-dtv)&&(OCR1BL)){OCR1AL=OCR1BL+dtv;}
    else{OCR1AL=0;} c--;dir=0;
    } 
  

 #asm("wdr")  
}

void main(void)
{
gpio_cfg();
t0_cfg();

#asm("sei")

while (1)
      {  


       
      }
}
